/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package complexcommand;
import java.util.*;
/**
 *
 * @author lynchcs
 */
public class CharacterCommandManager {
  private Deque<ICharacterCommand> commands = new LinkedList();
  private Deque<ICharacterCommand> undoCommands = new LinkedList();
  private Deque<ICharacterCommand> redoCommands = new LinkedList();
  
  public CharacterCommandManager() {
  }
  
  public void add(ICharacterCommand command) {
    if(commands != null) {
      commands.add(command);
    }    
  }
  
  public void execute() {
    ICharacterCommand command=null;    
    while(!commands.isEmpty()) {
      command = commands.removeFirst();
      if(command != null) {
        command.execute();
        undoCommands.add(command);
      }
    }
  }

  public void undo() {
    ICharacterCommand command=null;
    if(!undoCommands.isEmpty()) {
      command = undoCommands.removeLast();
      if(command != null) {
        command.undo();
        redoCommands.add(command);
      }
    }
  }

  public void redo() {
    ICharacterCommand command=null;
    if(!redoCommands.isEmpty()) {
      command = redoCommands.removeLast();
      if(command != null) {
        command.execute();      
      }
    }
  }
  
  
  
}
